import sk.thenet.app.*;
import sk.thenet.prog.*;
import game.*;

class Main extends SApp {
	public static var inst:Main;
	public static var prng:PRNGXORShift;
	public static var snd_enable:Bool = true;
	public static var snd_vol:Float = 1;
	public static var mus_enable:Bool = true;
	public static var mus_vol:Float = 1;
	
	public static function main(){
		haxe.Log.setColor(0xFF8000);
		Assets.init();
		prng = new PRNGXORShift(0xAB0DE327);
		inst = new Main();
	}
	
	public function new(){
		super();
		initBitmap(240, 320, 2);
		initKeyboard();
		initMouse();
		addState(new GSMenu(this));
		addState(new GSGame(this));
		addState(new GSIntro(this));
		addState(new GSVictory(this));
		addState(new GSGameover(this));
		applyState(getStateById("menu"));
	}
}