package game;

import sk.thenet.FM;
import sk.thenet.app.*;

class EBullet extends Entity {
	public static inline var BT_PLAYER_REG:Int = 0;
	public static inline var BT_BEE_STINGER:Int = 1;
	public static inline var BT_BIRD_POO:Int = 2;
	public static inline var BT_PLAYER_NINJA1:Int = 3;
	public static inline var BT_PLAYER_NINJA2:Int = 4;
	public static inline var BT_PLAYER_NINJA3:Int = 5;
	public static inline var BT_PLAYER_NINJA4:Int = 6;
	public static inline var BT_PLAYER_NINJA5:Int = 7;
	public static inline var BT_MOUSE1:Int = 8;
	public static inline var BT_MOUSE2:Int = 9;
	public static inline var BT_MOUSE3:Int = 10;
	public static inline var BT_BIGMOUSE1:Int = 11;
	public static inline var BT_BIGMOUSE2:Int = 12;
	public static inline var BT_BIGMOUSE3:Int = 13;
	public static inline var BT_BIGMOUSE4:Int = 14;
	public static inline var BT_BIGMOUSE5:Int = 15;
	public static inline var BT_BIGMOUSE6:Int = 16;
	public static inline var BT_BIGMOUSE7:Int = 17;
	public static inline var BT_BIGMOUSE8:Int = 18;
	public static inline var BT_BIGMOUSE9:Int = 19;
	public static inline var BT_BIGMOUSE10:Int = 20;
	public static inline var BT_BIGMOUSE11:Int = 21;
	public static inline var BT_BIGMOUSE12:Int = 22;
	public static inline var BT_BIGMOUSE13:Int = 23;
	public static inline var BT_BIGMOUSE14:Int = 24;
	public static inline var BT_BIGMOUSE15:Int = 25;
	public static inline var BT_BIGMOUSE16:Int = 26;
	public static inline var BT_DOG:Int = 27;
	
	public static var BIGMOUSE_VEL:Array<Int> = [
		4, 0,
		4, 1,
		3, 3,
		1, 4,
		0, 4,
		-1, 4,
		-3, 3,
		-4, 1,
		-4, 0,
		-4, -1,
		-3, -3,
		-1, -4,
		0, -4,
		1, -4,
		3, -3,
		4, -1
	];
	
	public var enemy:Bool = true;
	public var btype:Int = 0;
	public var bdmg:Int = 0;
	public var vx:Int = 0;
	public var vy:Int = 0;
	public var ph:Int = 0;
	public var autorem:Bool = false;
	
	public function new(nenemy:Bool, nx:Int, ny:Int, ngs:GSGame, ntype:Int = 0){
		enemy = nenemy;
		super(enemy ? Entity.ET_ENEMY_BULLET : Entity.ET_PLAYER_BULLET, ngs);
		btype = ntype;
		x = nx;
		y = ny;
		switch (btype){
			case BT_PLAYER_REG:
			vy = -5;
			bdx = 16;
			bdy = 8;
			bdw = 16;
			bdh = 10;
			bdox = -8;
			bdmg = 5;
			case BT_BEE_STINGER:
			vy = 3;
			bdx = 136;
			bdy = 32;
			bdw = 5;
			bdh = 8;
			bdox = -2;
			bdoy = -4;
			bdmg = 5;
			case BT_BIRD_POO:
			vy = 4;
			bdx = 232;
			bdy = 40;
			bdw = 8;
			bdh = 16;
			bdox = -4;
			bdoy = -8;
			bdmg = 3;
			case BT_PLAYER_NINJA1 | BT_PLAYER_NINJA2 | BT_PLAYER_NINJA3 | BT_PLAYER_NINJA4 | BT_PLAYER_NINJA5:
			vy = -5;
			if (btype == BT_PLAYER_NINJA2 || btype == BT_PLAYER_NINJA4){
				vy = -4;
				vx = (btype == BT_PLAYER_NINJA2 ? -1 : 1);
			} else if (btype == BT_PLAYER_NINJA1 || btype == BT_PLAYER_NINJA5){
				vy = -3;
				vx = (btype == BT_PLAYER_NINJA1 ? -2 : 2);
			}
			bdx = 32 + (btype - BT_PLAYER_NINJA1) * 8;
			bdy = 8;
			bdw = 8;
			bdh = 8;
			bdox = -4;
			bdmg = 3;
			case BT_MOUSE1 | BT_MOUSE2 | BT_MOUSE3:
			vy = (btype == BT_MOUSE2 ? 4 : 3);
			vx = (btype == BT_MOUSE1 ? -1 : (btype == BT_MOUSE3 ? 1 : 0));
			bdx = 136;
			bdy = 180;
			bdw = 7;
			bdh = 7;
			bdox = -3;
			bdoy = -7;
			bdmg = 5;
			case a if (a >= BT_BIGMOUSE1 && a <= BT_BIGMOUSE16):
			vx = BIGMOUSE_VEL[(a - BT_BIGMOUSE1) << 1];
			vy = BIGMOUSE_VEL[((a - BT_BIGMOUSE1) << 1) + 1];
			bdx = 164;
			bdy = 180;
			bdw = 7;
			bdh = 7;
			bdox = -3;
			bdoy = -3;
			bdmg = 8;
			case BT_DOG:
			vx = 0;
			vy = 0;
			bdx = 164;
			bdy = 180;
			bdw = 7;
			bdh = 7;
			bdox = -3;
			bdoy = -3;
			bdmg = 8;
		}
		dotick = true;
	}
	
	override public function tick(st:SApp):Void {
		var col = false;
		if (enemy){
			switch (btype){
				case BT_BEE_STINGER:
				bdx = 136 + ph * 5;
				ph++;
				ph %= 4;
				case BT_BIRD_POO:
				bdx = 232 + ph * 8;
				ph++;
				ph %= 4;
				case BT_MOUSE1 | BT_MOUSE2 | BT_MOUSE3:
				bdx = 136 + ph * 7;
				ph++;
				ph %= 4;
				case a if (a >= BT_BIGMOUSE1 && a <= BT_DOG):
				bdx = 164 + ph * 7;
				ph++;
				ph %= 4;
			}
			var pe = gs.player;
			if (x + bdox + bdw >= pe.x + pe.hbx && x + bdox < pe.x + pe.hbx + pe.hbw
				&& y + bdoy + bdh >= pe.y + pe.hby && y + bdoy < pe.y + pe.hby + pe.hbh){
				pe.damage(bdmg);
				if (btype == BT_BIRD_POO){
					Noises.playPoop();
					gs.blockScreen();
				}
				col = true;
			}
		} else {
			var ce = gs.entsep[Entity.ET_ENEMY].n;
			while (ce != null && ce.type == Entity.ET_ENEMY){
				if (x + 8 >= ce.x + ce.bdox && x - 8 < ce.x + ce.bdox + ce.bdw
					&& y + 10 >= ce.y + ce.bdoy && y < ce.y + ce.bdoy + ce.bdh){
					(cast ce:EEnemy).hp -= bdmg;
					Noises.playEnemyHurt();
					ce.hurt = 2;
					col = true;
					break;
				}
				ce = ce.n;
			}
		}
		if (btype != BT_DOG){
			var lphy:Int = gs.lvl.ph >> 3;
			var lphsy:Int = gs.lvl.ph % 8;
			var tx:Int = x >> 3;
			var ty:Int = 40 - ((y - lphsy) >> 3);
			var lvli:Int = tx + (ty + lphy) * 30;
			var lvlt:Int = (lvli >= 0 && lvli < gs.lvl.tdata.length ? gs.lvl.tdata[lvli] : 0);
			if (!col && (lvlt == 1 || lvlt == 10)){
				gs.spawnBulletSplash(x, y, vy);
				Noises.playHurt();
				col = true;
			}
		}
		x += vx;
		y += vy;
		if (!autorem){
			if (col) remove = true;
		} else {
			if (col || y < -10 || y >= 330 || (btype != BT_DOG && (x < -10 || x >= 250))){
				remove = true;
			}
		}
	}
}