package game;

import sk.thenet.app.*;
import sk.thenet.prog.*;

class EEMouse extends EEnemy {
	public var lx:Int = -1;
	public var ly:Int = -1;
	
	public function new(ngs:GSGame, nspawner:Wave.Spawner, nmovefunc:Int->EEnemy->Void){
		super(ngs, nspawner, nmovefunc);
		bdx = 136;
		bdy = 152;
		bdw = 22;
		bdh = 28;
		bdox = -11;
		bdoy = -14;
		hp = 50;
	}
	
	override public function tick(st:SApp):Void {
		super.tick(st);
		if (lx != -1){
			for (p in new LGBresenham(lx, ly, x, y)){
				gs.spawnMousetail(p.x - 2, p.y - 7);
			}
		}
		lx = x;
		ly = y;
		if (Main.prng.nextMod(30) == 0){
			bdx = 136 + Main.prng.nextMod(3) * 22;
		}
		if (Main.prng.nextMod(50) == 0){
			Noises.playMouse();
		}
		if (ph % 50 == 0){
			gs.addEntity(new EBullet(true, x, y + 4, gs, EBullet.BT_MOUSE1));
			gs.addEntity(new EBullet(true, x, y + 4, gs, EBullet.BT_MOUSE2));
			gs.addEntity(new EBullet(true, x, y + 4, gs, EBullet.BT_MOUSE3));
		}
	}
}