package game;

import sk.thenet.FM;
import sk.thenet.app.*;

class EYarnball extends Entity {
	public function new(nx:Int, ny:Int, ngs:GSGame){
		super(Entity.ET_YARNBALL, ngs);
		bdx = 216;
		bdy = 0;
		bdw = 24;
		bdh = 32;
		bdox = -12;
		bdoy = -20;
		x = nx;
		y = ny;
		dotick = true;
	}
	
	override public function tick(st:SApp):Void {
		var dx:Int = gs.player.x - x;
		var dy:Int = gs.player.y - y;
		var dist:Float = Math.sqrt(dx * dx + dy * dy) + 10;
		var force:Float = 1500 / (dist * dist);
		var fx:Float = force * (dx / dist);
		var fy:Float = force * (dy / dist);
		gs.player.yfx -= fx;
		gs.player.yfy -= fy;
		y++;
		if (y >= 360){
			remove = true;
		}
	}
}