package game;

import sk.thenet.app.*;
import sk.thenet.bmp.*;

class Entity {
	public static inline var ET_NONE:Int = 0;
	public static inline var ET_PLAYER:Int = 1;
	public static inline var ET_YARNBALL:Int = 1;
	public static inline var ET_ENEMY:Int = 2;
	public static inline var ET_COLLECT:Int = 3;
	public static inline var ET_PLAYER_BULLET:Int = 4;
	public static inline var ET_ENEMY_BULLET:Int = 5;
	
	public var visible:Bool = true;
	public var x:Int = 0;
	public var y:Int = 0;
	public var bd:Int = 0;
	public var bdox:Int = 0;
	public var bdoy:Int = 0;
	public var bdx:Int = 0;
	public var bdy:Int = 0;
	public var bdw:Int = 0;
	public var bdh:Int = 0;
	public var bdreg:Bool = true;
	public var bddyn:Bool = false;
	public var dotick:Bool = false;
	public var hurt:Int = 0;
	
	public var gs:GSGame;
	public var type:Int = 0;
	public var layer:Bool = false;
	public var remove:Bool = false;
	public var n:Entity = null;
	
	public function new(ntype:Int, ngs:GSGame){
		type = ntype;
		gs = ngs;
	}
	
	public function render(bd:BitmapData):Void {
		// override
	}
	
	public function tick(st:SApp):Void {
		// override
	}
}