package game;

import haxe.ds.Vector;
import sk.thenet.FM;
import sk.thenet.app.*;
import sk.thenet.bmp.*;

class GSVictory extends SSApp {
	public var ph:Int;
	
	public function new(nstater){
		super("victory", nstater);
	}
	
	override public function to():Void {
		ph = 0;
	}
	
	override public function tick():Void {
		stater.bd.fill(Assets.aGame.get(0, 0));
		
		var s:String = "CONGRATULATIONS!\nYOU HAVE DEFEATED\nTHE FORCES OF EVIL\n\nAND ALL THAT.\n\nThank you for playing Nightshift!\nAn LD48 game by Aurel B%l&.\nSpecial thanks to Lily.";
		s = s.substr(0, FM.floor((ph / 120) * s.length));
		Assets.fFontMi.render(stater.bd, s, 8, 8, 100);
		
		if (ph > 150){
			Assets.fFontMi.render(stater.bd, "             Press any key", 0, 200, 100);
		}
		
		if (ph < 160)
			ph++;
	}
	
	override public function kUp(kc:Int):Void {
		if (ph > 150){
			Main.inst.applyState(Main.inst.getStateById("menu"));
		}
	}
}