package game;

import flash.events.SampleDataEvent;
import flash.media.Sound;
import flash.media.SoundTransform;
import flash.media.SoundChannel;
import sk.thenet.plustd.audio.music.*;

@:sound("assets/s_bark.wav")			class SoundBark extends flash.media.Sound {}
@:sound("assets/s_bossclear.wav")		class SoundBossClear extends flash.media.Sound {}
@:sound("assets/s_collide.wav")			class SoundCollide extends flash.media.Sound {}
@:sound("assets/s_crush.wav")			class SoundCrush extends flash.media.Sound {}
@:sound("assets/s_death.wav")			class SoundDeath extends flash.media.Sound {}
@:sound("assets/s_enemy_hurt.wav")		class SoundEnemyHurt extends flash.media.Sound {}
@:sound("assets/s_hit_player.wav")		class SoundHitPlayer extends flash.media.Sound {}
@:sound("assets/s_hurt.wav")			class SoundHurt extends flash.media.Sound {}
@:sound("assets/s_intro1.wav")			class SoundIntro1 extends flash.media.Sound {}
@:sound("assets/s_intro2.wav")			class SoundIntro2 extends flash.media.Sound {}
@:sound("assets/s_intro3.wav")			class SoundIntro3 extends flash.media.Sound {}
@:sound("assets/s_level.wav")			class SoundLevel extends flash.media.Sound {}
@:sound("assets/s_life.wav")			class SoundLife extends flash.media.Sound {}
@:sound("assets/s_meow1.wav")			class SoundMeow extends flash.media.Sound {}
@:sound("assets/s_mouse.wav")			class SoundMouse extends flash.media.Sound {}
@:sound("assets/s_poop.wav")			class SoundPoop extends flash.media.Sound {}
@:sound("assets/s_splash.wav")			class SoundSplash extends flash.media.Sound {}
@:sound("assets/s_treat.wav")			class SoundTreat extends flash.media.Sound {}
@:sound("assets/s_waveclear.wav")		class SoundWaveClear extends flash.media.Sound {}
	
@:sound("assets/s_loopboss.wav")		class SoundLoopBoss extends flash.media.Sound {}
//@:sound("assets/s_.wav") class Sound extends flash.media.Sound {}
// mp3 works too

class Noises {
	public inline static function playSound(snd):Void {
		if (!Main.snd_enable) return;
		snd.play(0, 0, Main.snd_vol != 1 ? new SoundTransform(Main.snd_vol) : null);
	}
	
	public static function playBark():Void				playSound(new SoundBark());
	public static function playBossClear():Void			playSound(new SoundBossClear());
	public static function playCollide():Void			playSound(new SoundCollide());
	public static function playCrush():Void				playSound(new SoundCrush());
	public static function playDeath():Void				playSound(new SoundDeath());
	public static function playEnemyHurt():Void			playSound(new SoundEnemyHurt());
	public static function playHitPlayer():Void			playSound(new SoundHitPlayer());
	public static function playHurt():Void				playSound(new SoundHurt());
	public static function playIntro1():Void			playSound(new SoundIntro1());
	public static function playIntro2():Void			playSound(new SoundIntro2());
	public static function playIntro3():Void			playSound(new SoundIntro3());
	public static function playLevel():Void				playSound(new SoundLevel());
	public static function playLife():Void				playSound(new SoundLife());
	public static function playMeow():Void				playSound(new SoundMeow());
	public static function playMouse():Void				playSound(new SoundMouse());
	public static function playPoop():Void				playSound(new SoundPoop());
	public static function playSplash():Void			playSound(new SoundSplash());
	public static function playTreat():Void				playSound(new SoundTreat());
	public static function playWaveClear():Void			playSound(new SoundWaveClear());
	
	public static function playLoopBoss():SoundChannel {
		if (!Main.mus_enable) return null;
		return (new SoundLoopBoss()).play(0, 1000, Main.mus_vol != 1 ? new SoundTransform(Main.mus_vol) : null);
	}
	
	/*
	public static function playEx():Void {
		var snd:Sound = new Sound();
		snd.addEventListener(SampleDataEvent.SAMPLE_DATA, function(e:SampleDataEvent){
			/*
			if (e.position > 16000) return;
			for (i in 0...8192){
				var val = (-0.25 + ((e.position + i) % 100) / 200) + (-0.125 + ((e.position + i) % 110) / 400);
				e.data.writeFloat(val);
				e.data.writeFloat(val);
			}
			//* /
		});
		snd.play();
	}*/
}

class NoiseDummy {
	public function new(){}
	public function stop():Void {}
}