package game;

class Particle {
	public static inline var PT_NONE:Int = 0;
	public static inline var PT_EXPLOSION:Int = 1;
	public static inline var PT_BIRD_POO:Int = 2;
	public static inline var PT_MOUSE_TAIL:Int = 3;
	public static inline var PT_BULLET_SPLASH:Int = 4;
	
	public var type:Int = 0;
	public var x:Int;
	public var y:Int;
	public var vx:Int;
	public var vy:Int;
	public var vsx:Int;
	public var vsy:Int;
	public var ph:Int;
	public var ttl:Int;
	public var vrn:Int;
	
	public function new(){
		reset();
	}
	
	public function reset():Void {
		type = 0;
		x = 0;
		y = 0;
		vx = 0;
		vy = 0;
		ph = 0;
		ttl = 0;
		vrn = 0;
	}
}