package sk.thenet.app;

import sk.thenet.logic.*;

class STApp implements StaterTransition<SSApp, SApp> {
	public var id:String;
	public var from:SSApp;
	public var to:SSApp;
	
	public function new(nid:String, nfrom:SSApp, nto:SSApp){
		id = nid;
		from = nfrom;
		to = nto;
	}
	
	public function apply(stater:SApp):Void {
		if (stater.currentState != from){
			return;
		}
		if (!stater.currentState.from()){
			return;
		}
		stater.currentState = to;
		stater.currentState.to();
	}
}