package sk.thenet.event;

class EMEvent extends Event {
	public var x:Int;
	public var y:Int;
	
	public function new(nes:EventSource, nx:Int, ny:Int, ntype:String){
		super(nes, ntype);
		x = nx;
		y = ny;
	}
}

class EMClick extends EMEvent {
	public function new(nes:EventSource, nx:Int, ny:Int){
		super(nes, nx, ny, "mclick");
	}
}

class EMDown extends EMEvent {
	public function new(nes:EventSource, nx:Int, ny:Int){
		super(nes, nx, ny, "mdown");
	}
}

class EMUp extends EMEvent {
	public function new(nes:EventSource, nx:Int, ny:Int){
		super(nes, nx, ny, "mup");
	}
}