package sk.thenet.event;

class EventSource {
	public var listento:Array<String>;
	public var listeners:Array<Dynamic->Bool>;
	
	public function new(){
		listento = [];
		listeners = [];
	}
	
	public function fireEvent(event:Event):Void {
		for (i in 0...listento.length){
			if (listento[i] == event.type && listeners[i](event)) break;
		}
	}
	
	public function listen<T:Event>(type:String, listener:T->Bool):Void {
		listento.push(type);
		listeners.push(listener);
	}
}