package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;
import sk.thenet.FM;

class MMPattern {
	public static function countSamples(beats:Float, tempo:Float):Int {
		return FM.floor(beats * (44100 / (tempo / 60)));
	}
	
	public var tempo_orig:Float;
	public var tempo:Float;
	public var effects:Array<MMEffect>;
	public var effects_step:Array<Int>;
	public var efph:Int = 0;
	public var eftrig:Bool = false;
	
	public function new(ntempo:Float){
		tempo_orig = ntempo;
		tempo = 44100 / (ntempo / 60);
		effects = [];
		effects_step = [];
	}
	
	public function reset():Void {
		efph = 0;
		eftrig = false;
	}
	
	public function addEffect(eff:MMEffect, step:Int):MMPattern {
		effects.push(eff);
		effects_step.push(step);
		return this;
	}
	
	public function setFreq(instr:MMInstrument, c:Int):Void {}
}