package sk.thenet.prog;

class PRNGGeneric implements PRNGenerator {
	private var f_next:Void->UInt;
	private var f_nextMod:UInt->UInt;
	private var f_nextFloat:Float->Float;
	
	public function new(){}
	
	public inline function funcNext(nf_next:Void->UInt):PRNGGeneric {
		f_next = nf_next;
		return this;
	}
	public inline function funcNextMod(nf_nextMod:UInt->UInt):PRNGGeneric {
		f_nextMod = nf_nextMod;
		return this;
	}
	public inline function funcNextFloat(nf_nextFloat:Float->Float):PRNGGeneric {
		f_nextFloat = nf_nextFloat;
		return this;
	}
	public inline function next():UInt {
		return f_next();
	}
	public inline function nextMod(max:UInt):UInt {
		return f_nextMod(max);
	}
	public inline function nextFloat(max:Float = 1):Float {
		return f_nextFloat(max);
	}
}