<?php
$lvls = scandir("levels");
foreach ($lvls as $lvl){
	if ($lvl[0] == ".") continue;
	$lrep = str_replace(array(
		" ",
		"x",
		".",
		"F",
		"R",
		"L",
		"N",
		"h",
		"w",
		"y"
	), array(
		"0, ",
		"1, ",
		"2, ",
		"0xFF03, ",
		"0xFF00, ",
		"0xFF01, ",
		"0xFF02, ",
		"0x8000, ",
		"0x8001, ",
		"0xFF10, "
	), file_get_contents("levels/".$lvl));
	file_put_contents("levels_out/".$lvl, $lrep);
	$lsplit = explode("/* begin ".$lvl." */", file_get_contents("game/Level.hx"));
	if (count($lsplit) < 2){
		echo $lvl." - nowhere to place level\n";
	} else if (count($lsplit) > 2){
		echo $lvl." - ambiguous\n";
	} else {
		$lrep = implode("\n\t\t\t", explode("\n", $lrep));
		$lsplit2 = explode("/* end */", $lsplit[1]);
		if (count($lsplit2) < 2){
			echo $lvl." - nowhere to end level\n";
		} else {
			$lsplit2[0] = "";
			file_put_contents("game/Level.hx", $lsplit[0]."/* begin ".$lvl." */\n\t\t\t".$lrep."\n\t\t\t".implode("/* end */", $lsplit2));
		}
	}
}
?>