package game;

import sk.thenet.app.*;

class EEBird extends EEnemy {
	public function new(ngs:GSGame, nspawner:Wave.Spawner, nmovefunc:Int->EEnemy->Void){
		super(ngs, nspawner, nmovefunc);
		bdx = 136;
		bdy = 40;
		bdw = 24;
		bdh = 20;
		bdox = -12;
		bdoy = -8;
		hp = 30;
	}
	
	override public function tick(st:SApp):Void {
		super.tick(st);
		var sph = ((ph >> 1) % 6);
		bdx = 136 + (sph < 4 ? sph * 24 : 48 + (4 - sph) * 24);
		if (sph == 3 || sph == 5){
			bdoy = -9;
		} else if (sph == 4){
			bdoy = -11;
		} else {
			bdoy = -8;
		}
		if (Main.prng.nextMod(50) == 0){
			gs.addEntity(new EBullet(true, x, y + 4, gs, EBullet.BT_BIRD_POO));
		}
	}
}