package game;

import sk.thenet.app.*;

class EEnemy extends Entity {
	public var ph:Int;
	public var spawner:Wave.Spawner;
	public var movefunc:Int->EEnemy->Void;
	public var hp:Int = 0;
	public var score:Int = 100;
	
	public function new(ngs:GSGame, nspawner:Wave.Spawner, nmovefunc:Int->EEnemy->Void){
		super(Entity.ET_ENEMY, ngs);
		spawner = nspawner;
		movefunc = nmovefunc;
		dotick = true;
	}
	
	override public function tick(st:SApp):Void {
		if (hp <= 0){
			gs.scorelvl += score;
			spawner.kill(this);
			gs.spawnExplosion(x, y, 10);
			Noises.playSplash();
			remove = true;
		}
		movefunc(ph, this);
		ph++;
	}
}