package game;

import haxe.ds.Vector;
import sk.thenet.FM;
import sk.thenet.app.*;
import sk.thenet.bmp.*;

class GSMenu extends SSApp {
	public var sel:Int;
	
	public function new(nstater){
		super("menu", nstater);
	}
	
	override public function to():Void {
		sel = 0;
	}
	
	override public function tick():Void {
		stater.bd.fill(Assets.aGame.get(0, 0));
		Assets.fFontMi.render(stater.bd, "NIGHTSHIFT\nAn LD48 game by Aurel B%l&.\n\n"
			+ (sel == 0 ? ">" : " ") + " Start\n"
			+ (sel == 1 ? ">" : " ") + " Music: " + (Main.mus_enable ? "on" : "off") + "\n"
			+ (sel == 2 ? ">" : " ") + " Sound: " + (Main.snd_enable ? "on" : "off") + "\n"
			+ (sel == 3 ? ">" : " ") + " More LD games by me"
			+ "\n\n[`@] to navigate\n[A] or [space] to confirm", 8, 8, 100);
	}
	
	override public function kUp(kc:Int):Void {
		if (kc == Keyboard.K_UP){
			sel += 3;
			sel %= 4;
		} else if (kc == Keyboard.K_DOWN){
			sel += 1;
			sel %= 4;
		} else if (kc == Keyboard.K_A || kc == Keyboard.K_SPACE){
			switch (sel){
				case 0: Main.inst.applyState(Main.inst.getStateById("intro"));
				case 1: Main.mus_enable = !Main.mus_enable;
				case 2: Main.snd_enable = !Main.snd_enable;
				case 3: flash.Lib.getURL(new flash.net.URLRequest("http://www.thenet.sk"), "_blank");
			}
		}
	}
}