package sk.thenet.app;

import flash.events.Event;
import flash.events.KeyboardEvent;
import flash.events.MouseEvent;
import sk.thenet.event.*;
import sk.thenet.FM;

class ESApp extends EventSource {
	private var stage:flash.display.Stage;
	
	public function new(){
		super();
		stage = flash.Lib.current.stage;
		stage.addEventListener(Event.ENTER_FRAME, frame);
		stage.addEventListener(MouseEvent.CLICK, mClick);
		stage.addEventListener(MouseEvent.MOUSE_DOWN, mDown);
		stage.addEventListener(MouseEvent.MOUSE_UP, mUp);
		stage.addEventListener(KeyboardEvent.KEY_DOWN, kDown);
		stage.addEventListener(KeyboardEvent.KEY_UP, kUp);
	}
	
	private function frame(e:Event):Void {
		fireEvent(new ETick(this));
	}
	
	private function mClick(e:MouseEvent):Void {
		var ev = new EMEvent.EMClick(this, FM.floor(stage.mouseX), FM.floor(stage.mouseY));
		fireEvent(ev);
	}
	
	public inline function mDown(e:MouseEvent):Void {
		fireEvent(new EMEvent.EMDown(this, FM.floor(stage.mouseX), FM.floor(stage.mouseY)));
	}
	
	public inline function mUp(e:MouseEvent):Void {
		fireEvent(new EMEvent.EMUp(this, FM.floor(stage.mouseX), FM.floor(stage.mouseY)));
	}
	
	public inline function kDown(e:KeyboardEvent):Void {
		fireEvent(new EKEvent.EKDown(this, e.keyCode));
	}
	
	public inline function kUp(e:KeyboardEvent):Void {
		fireEvent(new EKEvent.EKUp(this, e.keyCode));
	}
}