package sk.thenet.app;

import haxe.ds.Vector;
import flash.events.KeyboardEvent;
import sk.thenet.event.*;

class Keyboard {
	public static inline var K_LEFT:Int = 0;
	public static inline var K_UP:Int = 1;
	public static inline var K_RIGHT:Int = 2;
	public static inline var K_DOWN:Int = 3;
	public static inline var K_SPACE:Int = 4;
	public static inline var K_T0:Int = 5;
	public static inline var K_T1:Int = 6;
	public static inline var K_T2:Int = 7;
	public static inline var K_T3:Int = 8;
	public static inline var K_T4:Int = 9;
	public static inline var K_T5:Int = 10;
	public static inline var K_T6:Int = 11;
	public static inline var K_T7:Int = 12;
	public static inline var K_T8:Int = 13;
	public static inline var K_T9:Int = 14;
	public static inline var K_A:Int = 15;
	public static inline var K_B:Int = 16;
	public static inline var K_C:Int = 17;
	public static inline var K_D:Int = 18;
	public static inline var K_E:Int = 19;
	public static inline var K_F:Int = 20;
	public static inline var K_G:Int = 21;
	public static inline var K_H:Int = 22;
	public static inline var K_I:Int = 23;
	public static inline var K_J:Int = 24;
	public static inline var K_K:Int = 25;
	public static inline var K_L:Int = 26;
	public static inline var K_M:Int = 27;
	public static inline var K_N:Int = 28;
	public static inline var K_O:Int = 29;
	public static inline var K_P:Int = 30;
	public static inline var K_Q:Int = 31;
	public static inline var K_R:Int = 32;
	public static inline var K_S:Int = 33;
	public static inline var K_T:Int = 34;
	public static inline var K_U:Int = 35;
	public static inline var K_V:Int = 36;
	public static inline var K_W:Int = 37;
	public static inline var K_X:Int = 38;
	public static inline var K_Y:Int = 39;
	public static inline var K_Z:Int = 40;
	
	public var down:Vector<Bool>;
	public var kmap:Vector<Int>;
	public var st:SApp;
	
	public function new(nst:SApp){
		st = nst;
		flash.Lib.current.stage.addEventListener(KeyboardEvent.KEY_DOWN, kDown);
		flash.Lib.current.stage.addEventListener(KeyboardEvent.KEY_UP, kUp);
		
		down = new Vector<Bool>(41);
		kmap = new Vector<Int>(41);
		var tkmap = [	37, // arrows
						38,
						39,
						40,
						32, // space
						48, // 0 - 9
						49,
						50,
						51,
						52,
						53,
						54,
						55,
						56,
						57,
						65, // a - z
						66,
						67,
						68,
						69,
						70,
						71,
						72,
						73,
						74,
						75,
						76,
						77,
						78,
						79,
						80,
						81,
						82,
						83,
						84,
						85,
						86,
						87,
						88,
						89,
						90];
		for (i in 0...down.length){
			down[i] = false;
			kmap[i] = tkmap[i];
		}
	}
	
	private function kDown(e:KeyboardEvent):Void {
		var kn = kSet(e.keyCode, true);
		if (kn != -1){
			st.kDown(new EKEvent.EKDown(st.es, kn));
		}
	}
	
	private function kUp(e:KeyboardEvent):Void {
		var kn = kSet(e.keyCode, false);
		if (kn != -1){
			st.kUp(new EKEvent.EKUp(st.es, kn));
		}
	}
	
	private function kSet(kc:Int, s:Bool):Int {
		for (i in 0...kmap.length){
			if (kmap[i] == kc){
				if (down[i] == s){
					return -1;
				}
				down[i] = s;
				return i;
			}
		}
		return -1;
	}
}