package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMEFade extends MMEffect {
	public var dir:Bool;
	public var time:Float;
	
	public function new(ndir:Bool, ntime:Float):Void {
		super();
		dir = ndir;
		time = ntime;
		reset();
	}
	
	override public function apply(buf:Float):Float {
		var phf:Float = dir ? (ph++ / time) : 1 - (ph++ / time);
		if (ph >= time) done = true;
		return buf * phf;
	}
}